# Author renyupeng
# coding=utf-8
# @Time    : 2021/9/27 10:50 上午
# @Site    : 
# @File    : AccountDailyReport.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import logging
from math import ceil

from Apietl.kwai_etl.report.ReplaceAccountInfo import ReplaceAccountInfo
from Apietl.utlis.Logger import Logger
from Apietl.utlis.Utils import Utils
from Apietl.conn.TidbConn import TidbConn


class AccountDailyReport:
    def __init__(self):
        self.conn = TidbConn.get_connection()
        self.parm = Utils.get_args()
        self.start_time = self.parm[0]
        self.end_time = self.parm[1]

    def daily_report(self):
        try:
            sql = """
            replace into application.kuaishou_account_report_daily_dw
(account_id, stat_date, project_id, product_id, advertiser_id, company_id, account_name, project_name, advertiser_name,
 company_name, sale_id, user_id, org_code, charge, `show`, photo_click, aclick, bclick, photo_click_ratio,
 play_3s_ratio, action_ratio, impression_1k_cost, photo_click_cost, action_cost, share, comment, `like`, follow,
 cancel_follow, report, block, negative, submit, download_started, download_completed, activation, event_pay_first_day,
 event_pay_purchase_amount_first_day, event_pay_first_day_roi, event_pay, event_pay_purchase_amount, event_pay_roi,
 event_register, event_register_cost, event_register_ratio, event_jin_jian_app, event_jin_jian_app_cost,
 event_credit_grant_app, event_credit_grant_app_cost, event_credit_grant_app_ratio, event_order_paid,
 event_order_paid_purchase_amount, event_order_paid_cost, event_next_day_stay, event_next_day_stay_cost,
 event_next_day_stay_ratio, form_count, form_cost, form_action_ratio, event_jin_jian_landing_page,
 event_jin_jian_landing_page_cost, event_credit_grant_landing_page, event_credit_grant_landing_page_cost,
 event_credit_grant_landing_page_ratio, event_valid_clues, event_valid_clues_cost, event_add_wechat,
 event_add_wechat_cost, event_add_wechat_ratio, event_get_through, event_get_through_cost, event_get_through_ratio,
 event_app_invoked, event_app_invoked_cost, event_app_invoked_ratio, event_credit_grant_landing_ratio, play_5s_ratio,
 play_end_ratio, event_new_user_pay, event_new_user_pay_cost, event_new_user_pay_ratio, click_1k_cost, ad_product_cnt,
 event_goods_view, merchant_reco_fans, event_order_amount_roi, event_goods_view_cost, merchant_reco_fans_cost,
 event_button_click, event_button_click_cost, event_button_click_ratio, event_order_paid_roi,
 event_new_user_jinjian_app, event_new_user_jinjian_app_cost, event_new_user_jinjian_app_roi,
 event_new_user_credit_grant_app, event_new_user_credit_grant_app_cost, event_new_user_credit_grant_app_roi,
 event_new_user_jinjian_page, event_new_user_jinjian_page_cost, event_new_user_jinjian_page_roi,
 event_new_user_credit_grant_page, event_new_user_credit_grant_page_cost, event_new_user_credit_grant_page_roi,
 event_appoint_form, event_appoint_form_cost, event_appoint_form_ratio, event_appoint_jump_click,
 event_appoint_jump_click_cost, event_appoint_jump_click_ratio, union_event_pay_purchase_amount_7d,
 union_event_pay_purchase_amount_7d_roi, placement_type, ad_scene, event_order_successed, ad_photo_played_10s_ratio,
 key_action_cost, event_add_shopping_cart_cost, event_ad_watch_times_ratio, event_outbound_call_cost,
 event_outbound_call, action_new_ratio, event_watch_app_ad, event_multi_conversion_cost, event_phone_card_activate,
 ad_photo_played_75percent_ratio, key_action_ratio, event_ad_watch_times_cost, event_add_shopping_cart, key_action,
 event_multi_conversion, event_wechat_connected, event_dsp_gift_form, event_intention_confirmed,
 event_phone_get_through, event_multi_conversion_ratio, event_measurement_house, ad_photo_played_2s_ratio,
 event_outbound_call_ratio, event_ad_watch_times,event_pay_purchase_amount_one_day_by_conversion,
  ad_photo_played_10s,
  ad_photo_played_2s,
  ad_photo_played_75percent,
  approx_pay_cost,
  approx_pay_count,
  approx_pay_ratio,cancel_like,
  click_conversion_ratio,
  conversion_cost,conversion_cost_by_impression_7d,conversion_num,conversion_num_by_impression_7d,conversion_num_cost,conversion_ratio,conversion_ratio_by_impression_7d,deep_conversion_cost,deep_conversion_cost_by_impression_7d,deep_conversion_num,deep_conversion_num_by_impression_7d,deep_conversion_ratio,deep_conversion_ratio_by_impression_7d,download_completed_cost,download_completed_ratio,download_conversion_ratio,download_installed,download_started_cost,download_started_ratio,event_24h_stay,event_24h_stay_by_conversion,event_24h_stay_by_conversion_cost,event_24h_stay_by_conversion_ratio,event_24h_stay_cost,event_24h_stay_ratio,event_ad_watch_10_times,event_ad_watch_10_times_cost,event_ad_watch_10_times_ratio,event_ad_watch_20_times,event_ad_watch_20_times_cost,event_ad_watch_20_times_ratio,event_ad_watch_5_times,event_ad_watch_5_times_cost,event_ad_watch_5_times_ratio,event_audition,event_consultation_valid_retained,event_consultation_valid_retained_cost,event_consultation_valid_retained_ratio,event_conversion_click_cost,event_conversion_click_ratio,event_credit_grant_first_day_app,event_credit_grant_first_day_app_cost,event_credit_grant_first_day_app_ratio,event_credit_grant_first_day_landing_page,event_credit_grant_first_day_landing_page_cost,event_credit_grant_first_day_landing_page_ratio,event_making_calls,event_making_calls_cost,event_making_calls_ratio,event_order_submit,event_pay_purchase_amount_one_day,event_pay_purchase_amount_one_day_by_conversion_roi,event_pay_purchase_amount_one_day_roi,event_pay_purchase_amount_three_day_by_conversion,event_pay_purchase_amount_three_day_by_conversion_roi,event_pay_purchase_amount_week_by_conversion,event_pay_purchase_amount_week_by_conversion_roi,event_pay_week_by_conversion,event_pay_week_by_conversion_cost,event_pay_weighted_purchase_amount,event_pay_weighted_purchase_amount_first_day,event_pre_component_consultation_valid_retained,event_three_day_stay_by_conversion,event_three_day_stay_by_conversion_cost,event_three_day_stay_by_conversion_ratio,event_wechat_qr_code_link_click,event_week_stay_by_conversion,event_week_stay_by_conversion_cost,event_week_stay_by_conversion_ratio,live_event_goods_view,live_played_3s,played_end,played_five_seconds,played_three_seconds,event_next_day_stay_new,event_next_day_stay_new_cost,event_next_day_stay_new_ratio,ad_show,event_credit_card_recheck,event_credit_card_recheck_first_day,event_no_intention,event_multi_pay_seven_day_by_conversion,event_multi_pay_seven_day_by_conversion_cost,mcb_left_time_perf_cpa_bid,mcb_left_time_perf_roi_ratio,mcb_all_day_perf_cpa_bid,mcb_all_day_perf_roi_ratio,live_room_avg_played_seconds,ad_live_share,ad_live_comment,live_played_started,live_played_started_cost,ad_live_follow,ad_live_follow_cost,simple_live_played_started,standard_live_played_started,conversion_component_impression,conversion_component_click,conversion_component_rate,ad_landing_page_impression,ad_app_download_half_impression
)
        select report.advertiser_id as account_id,
               stat_date,
               project_id,
               product_id,
               sys.advertiser_id,
               company_id,
               account_name,
               project_name,
               advertiser_name,
               company_name,
               sale_id,
               user_id,
               org_code,
               charge,
               `show`,
               photo_click,
               aclick,
               bclick,
               photo_click_ratio,
               play_3s_ratio,
               action_ratio,
               impression_1k_cost,
               photo_click_cost,
               action_cost,
               share,
               comment,
               `like`,
               follow,
               cancel_follow,
               report,
               block,
               negative,
               submit,
               download_started,
               download_completed,
               activation,
               event_pay_first_day,
               event_pay_purchase_amount_first_day,
               event_pay_first_day_roi,
               event_pay,
               event_pay_purchase_amount,
               event_pay_roi,
               event_register,
               event_register_cost,
               event_register_ratio,
               event_jin_jian_app,
               event_jin_jian_app_cost,
               event_credit_grant_app,
               event_credit_grant_app_cost,
               event_credit_grant_app_ratio,
               event_order_paid,
               event_order_paid_purchase_amount,
               event_order_paid_cost,
               event_next_day_stay,
               event_next_day_stay_cost,
               event_next_day_stay_ratio,
               form_count,
               form_cost,
               form_action_ratio,
               event_jin_jian_landing_page,
               event_jin_jian_landing_page_cost,
               event_credit_grant_landing_page,
               event_credit_grant_landing_page_cost,
               event_credit_grant_landing_page_ratio,
               event_valid_clues,
               event_valid_clues_cost,
               event_add_wechat,
               event_add_wechat_cost,
               event_add_wechat_ratio,
               event_get_through,
               event_get_through_cost,
               event_get_through_ratio,
               event_app_invoked,
               event_app_invoked_cost,
               event_app_invoked_ratio,
               event_credit_grant_landing_ratio,
               play_5s_ratio,
               play_end_ratio,
               event_new_user_pay,
               event_new_user_pay_cost,
               event_new_user_pay_ratio,
               click_1k_cost,
               ad_product_cnt,
               event_goods_view,
               merchant_reco_fans,
               event_order_amount_roi,
               event_goods_view_cost,
               merchant_reco_fans_cost,
               event_button_click,
               event_button_click_cost,
               event_button_click_ratio,
               event_order_paid_roi,
               event_new_user_jinjian_app,
               event_new_user_jinjian_app_cost,
               event_new_user_jinjian_app_roi,
               event_new_user_credit_grant_app,
               event_new_user_credit_grant_app_cost,
               event_new_user_credit_grant_app_roi,
               event_new_user_jinjian_page,
               event_new_user_jinjian_page_cost,
               event_new_user_jinjian_page_roi,
               event_new_user_credit_grant_page,
               event_new_user_credit_grant_page_cost,
               event_new_user_credit_grant_page_roi,
               event_appoint_form,
               event_appoint_form_cost,
               event_appoint_form_ratio,
               event_appoint_jump_click,
               event_appoint_jump_click_cost,
               event_appoint_jump_click_ratio,
               union_event_pay_purchase_amount_7d,
               union_event_pay_purchase_amount_7d_roi,
               placement_type,
               ad_scene,
               event_order_successed,
               ad_photo_played_10s_ratio,
               key_action_cost,
               event_add_shopping_cart_cost,
               event_ad_watch_times_ratio,
               event_outbound_call_cost,
               event_outbound_call,
               action_new_ratio,
               event_watch_app_ad,
               event_multi_conversion_cost,
               event_phone_card_activate,
               ad_photo_played_75percent_ratio,
               key_action_ratio,
               event_ad_watch_times_cost,
               event_add_shopping_cart,
               key_action,
               event_multi_conversion,
               event_wechat_connected,
               event_dsp_gift_form,
               event_intention_confirmed,
               event_phone_get_through,
               event_multi_conversion_ratio,
               event_measurement_house,
               ad_photo_played_2s_ratio,
               event_outbound_call_ratio,
               event_ad_watch_times,
               event_pay_purchase_amount_one_day_by_conversion,
                ad_photo_played_10s
                ,ad_photo_played_2s
,ad_photo_played_75percent
,approx_pay_cost
,approx_pay_count
,approx_pay_ratio
,cancel_like
,click_conversion_ratio
,conversion_cost
,conversion_cost_by_impression_7d
,conversion_num
,conversion_num_by_impression_7d
,conversion_num_cost
,conversion_ratio
,conversion_ratio_by_impression_7d
,deep_conversion_cost
,deep_conversion_cost_by_impression_7d
,deep_conversion_num
,deep_conversion_num_by_impression_7d
,deep_conversion_ratio
,deep_conversion_ratio_by_impression_7d
,download_completed_cost
,download_completed_ratio
,download_conversion_ratio
,download_installed
,download_started_cost
,download_started_ratio
,event_24h_stay
,event_24h_stay_by_conversion
,event_24h_stay_by_conversion_cost
,event_24h_stay_by_conversion_ratio
,event_24h_stay_cost
,event_24h_stay_ratio
,event_ad_watch_10_times
,event_ad_watch_10_times_cost
,event_ad_watch_10_times_ratio
,event_ad_watch_20_times
,event_ad_watch_20_times_cost
,event_ad_watch_20_times_ratio
,event_ad_watch_5_times
,event_ad_watch_5_times_cost
,event_ad_watch_5_times_ratio
,event_audition
,event_consultation_valid_retained
,event_consultation_valid_retained_cost
,event_consultation_valid_retained_ratio
,event_conversion_click_cost
,event_conversion_click_ratio
,event_credit_grant_first_day_app
,event_credit_grant_first_day_app_cost
,event_credit_grant_first_day_app_ratio
,event_credit_grant_first_day_landing_page
,event_credit_grant_first_day_landing_page_cost
,event_credit_grant_first_day_landing_page_ratio
,event_making_calls
,event_making_calls_cost
,event_making_calls_ratio
,event_order_submit
,event_pay_purchase_amount_one_day
,event_pay_purchase_amount_one_day_by_conversion_roi
,event_pay_purchase_amount_one_day_roi
,event_pay_purchase_amount_three_day_by_conversion
,event_pay_purchase_amount_three_day_by_conversion_roi
,event_pay_purchase_amount_week_by_conversion
,event_pay_purchase_amount_week_by_conversion_roi
,event_pay_week_by_conversion
,event_pay_week_by_conversion_cost
,event_pay_weighted_purchase_amount
,event_pay_weighted_purchase_amount_first_day
,event_pre_component_consultation_valid_retained
,event_three_day_stay_by_conversion
,event_three_day_stay_by_conversion_cost
,event_three_day_stay_by_conversion_ratio
,event_wechat_qr_code_link_click
,event_week_stay_by_conversion
,event_week_stay_by_conversion_cost
,event_week_stay_by_conversion_ratio
,live_event_goods_view
,live_played_3s
,played_end
,played_five_seconds
,played_three_seconds
,event_next_day_stay_new
,event_next_day_stay_new_cost
,event_next_day_stay_new_ratio
,ad_show
,event_credit_card_recheck
,event_credit_card_recheck_first_day
,event_no_intention
,event_multi_pay_seven_day_by_conversion
,event_multi_pay_seven_day_by_conversion_cost
,mcb_left_time_perf_cpa_bid
,mcb_left_time_perf_roi_ratio
,mcb_all_day_perf_cpa_bid
,mcb_all_day_perf_roi_ratio
,live_room_avg_played_seconds
,ad_live_share
,ad_live_comment
,live_played_started
,live_played_started_cost
,ad_live_follow
,ad_live_follow_cost
,simple_live_played_started
,standard_live_played_started
,conversion_component_impression
,conversion_component_click
,conversion_component_rate
,ad_landing_page_impression
,ad_app_download_half_impression

               
        from media_api.kuaishou_account_report_daily report
                 left join
             (SELECT
cua.account_id id,
cua.account_id account_id,
cp.id project_id,
product.id product_id,
ca.id advertiser_id,
uc.company_id company_id,
cua.auth_name account_name,
cp.project_name project_name,
ca.`name` advertiser_name,
uc.company_name company_name,
cp.sale_id sale_id,
su.id user_id,
su.leader_id,
su.org_code org_code
FROM
`jeecg-boot`.ctop_user_allocation cua
LEFT JOIN `jeecg-boot`.ctop_project cp ON cua.project_id = cp.id
LEFT JOIN `jeecg-boot`.ctop_advertiser ca ON ca.id = cua.advertiser_id
LEFT JOIN `jeecg-boot`.sys_user su ON su.id = cua.user_id
LEFT JOIN `jeecg-boot`.user_company uc ON uc.user_id = cua.user_id
LEFT JOIN `jeecg-boot`.ctop_product product ON product.id = cp.product_id
WHERE
cua.account_id IS NOT NULL
             ) sys
             on report.advertiser_id = sys.account_id
        where report.stat_date between {start_time} and {end_time}
        """.format(start_time=self.start_time, end_time=self.end_time)
            print(sql)
            TidbConn.upsert(conn=self.conn, sql_buff=sql)
            self.conn.commit()
            TidbConn.conn_close(conn=self.conn)
            return 0
        except Exception as e:
            logging.error(e)
            return -1


if __name__ == '__main__':
    status = AccountDailyReport().daily_report()
    if status == 0:
        print("作业执行成功")
        exit(0)
    else:
        print("作业执行失败")
        exit(-1)
